package de.andrena.objektforum.timeconcepts;

import static de.andrena.objektforum.timeconcepts.Util.formatInstant;
import static de.andrena.objektforum.timeconcepts.Util.formatLocalDateTime;
import static java.time.Month.JANUARY;

import java.time.Instant;
import java.time.LocalDateTime;
import java.time.ZoneId;

import org.junit.jupiter.api.Test;

public class LocalDateTimeToInstant {

    @Test
    void localDateTimeToInstant() {
        LocalDateTime newYear = LocalDateTime.of(2020, JANUARY, 1, 0, 0, 0);
        System.out.println(formatLocalDateTime(newYear));
        System.out.println();

        Instant newYearInLondon = newYear.atZone(ZoneId.of("UTC")).toInstant();
        Instant newYearInNYC = newYear.atZone(ZoneId.of("America/New_York")).toInstant();
        Instant newYearInSystemDefault = newYear.atZone(ZoneId.systemDefault()).toInstant();
        Instant newYearInSingapore = newYear.atZone(ZoneId.of("Asia/Singapore")).toInstant();

        System.out.println(formatInstant(newYearInLondon) + " (London's new year)");
        System.out.println(formatInstant(newYearInNYC) + " (New York's new year)");
        System.out.println(formatInstant(newYearInSystemDefault) + " (our new year)");
        System.out.println(formatInstant(newYearInSingapore) + " (Singapore's new year)");
    }
}
